import 'package:fealm/commons/FieldWrapper.dart';
import 'package:fealm/commons/StringBuilder.dart';
import 'package:fealm/model/Many2One.dart';
import 'package:sprintf/sprintf.dart';
import 'package:sqflite/sqlite_api.dart';
import 'FealmObject.dart';

class FealmQuery<T>{

  FealmObject fealmObject;
  StringBuilder _sb;
  List<dynamic> _args;


  FealmQuery.where(FealmObject fealmObject){
    this.fealmObject = fealmObject;
    this._sb = new StringBuilder();
    this._args = List();
  }
  
  and() => _sb.append(' and ');

  or() => _sb.append(' or ');


  equalToInt(String field, int value){
     _sb.append(sprintf('%s = ?',[field]));
     _args.add(value);
     return this;
  }

  equalToString(String field, String value){
    _sb.append(sprintf('%s = ?',[field]));
    _args.add(value);
    return this;
  }

  equalToBool(String field, bool value){
    _sb.append(sprintf('%s = ?',[field]));
    _args.add(FieldWrapper.fromBool(value));
    return this;
  }

  equalToMany2One(String field, Many2One value){
    if(value!=null) {
      _sb.append(sprintf('%s = ?', [field]));
      _args.add(FieldWrapper.fromMany2One(value));
    }
    return this;
  }



  Future<List<Map<String,dynamic>>> findAll(Database db) {
     Future<List<Map<String,dynamic>>> results =  db.query(fealmObject.getModelName(),
         where: _sb.toString(), whereArgs: _args);
     return results;
  }
}